#include "util.hpp"

std::string str(glm::vec2 v) { return array_string(&v.x, 2); }
std::string str(glm::vec3 v) { return array_string(&v.x, 3); }
std::string str(glm::vec4 v) { return array_string(&v.x, 4); }
std::string str(glm::ivec2 v) { return array_string(&v.x, 2); }
std::string str(glm::ivec3 v) { return array_string(&v.x, 3); }
std::string str(glm::ivec4 v) { return array_string(&v.x, 4); }
std::string str(glm::uvec2 v) { return array_string(&v.x, 2); }
std::string str(glm::uvec3 v) { return array_string(&v.x, 3); }
std::string str(glm::uvec4 v) { return array_string(&v.x, 4); }
std::string str(glm::mat3 v) { return "[" + array_string(&v[0].x, 3) + " | " + array_string(&v[1].x, 3) + " | " + array_string(&v[2].x, 3) + "]"; }
std::string str(glm::mat4 v) { return "[" + array_string(&v[0].x, 4) + " | " + array_string(&v[1].x, 4) + " | " + array_string(&v[2].x, 4) + " | " + array_string(&v[3].x, 4) + "]"; }


double MiniTimer::restart() {
    auto ret = elapsed();
    m_startTime = std::chrono::high_resolution_clock::now();
    return ret;
}
